import { ElementRef, Renderer2, ChangeDetectorRef, AfterViewInit, OnDestroy } from "@angular/core";
import { IMyDate } from "../../interfaces/my-date.interface";
import { IMyDateRange } from "../../interfaces/my-date-range.interface";
import { IMyMonth } from "../../interfaces/my-month.interface";
import { IMyCalendarDay } from "../../interfaces/my-calendar-day.interface";
import { IMyCalendarMonth } from "../../interfaces/my-calendar-month.interface";
import { IMyCalendarYear } from "../../interfaces/my-calendar-year.interface";
import { IMyWeek } from "../../interfaces/my-week.interface";
import { IMyOptions } from "../../interfaces/my-options.interface";
import { IMySelectorPosition } from "../../interfaces/my-selector-pos.interface";
import { IMyCalendarViewChanged } from "../../interfaces/my-calendar-view-changed.interface";
import { IMyDateModel } from "../../interfaces/my-date-model.interface";
import { IMyRangeDateSelection } from "../../interfaces/my-range-date-selection.interface";
import { IMyCalendarAnimation } from "../../interfaces/my-calendar-animation.interface";
import { IMyDefaultMonth } from "../../interfaces/my-default-month.interface";
import { UtilService } from "../../services/angular-mydatepicker.util.service";
import { DefaultView } from "../../enums/default-view.enum";
import { HeaderAction } from "../../enums/header-action.enum";
import { ActiveView } from "../../enums/active-view.enum";
export declare class CalendarComponent implements AfterViewInit, OnDestroy {
    private elem;
    private renderer;
    private cdr;
    private utilService;
    selectorEl: ElementRef;
    styleEl: ElementRef;
    position: string;
    opts: IMyOptions;
    visibleMonth: IMyMonth;
    selectedMonth: IMyMonth;
    selectedDate: IMyDate;
    selectedDateRange: IMyDateRange;
    weekDays: Array<string>;
    dates: Array<IMyWeek>;
    months: Array<Array<IMyCalendarMonth>>;
    years: Array<Array<IMyCalendarYear>>;
    yearsDuration: string;
    dayIdx: number;
    weekDayOpts: Array<string>;
    selectMonth: boolean;
    selectYear: boolean;
    viewChanged: boolean;
    dateChanged: (dm: IMyDateModel, close: boolean) => void;
    calendarViewChanged: (cvc: IMyCalendarViewChanged) => void;
    rangeDateSelection: (rds: IMyRangeDateSelection) => void;
    viewActivated: (va: ActiveView) => void;
    closedByEsc: () => void;
    selectorPos: IMySelectorPosition;
    prevViewDisabled: boolean;
    nextViewDisabled: boolean;
    mCurrentMode: number;
    clickListener: () => void;
    constructor(elem: ElementRef, renderer: Renderer2, cdr: ChangeDetectorRef, utilService: UtilService);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    initializeComponent(opts: IMyOptions, defaultMonth: IMyDefaultMonth, selectedValue: any, inputValue: string, selectorPos: IMySelectorPosition, dc: (dm: IMyDateModel, close: boolean) => void, cvc: (cvc: IMyCalendarViewChanged) => void, rds: (rds: IMyRangeDateSelection) => void, va: (va: ActiveView) => void, cbe: () => void): void;
    initializeView(defaultMonth: IMyDefaultMonth, selectedValue: any, inputValue: string): void;
    refreshComponent(opts: IMyOptions, defaultMonth: IMyDefaultMonth, selectedValue: any, inputValue: string): void;
    headerAction(headerAction: HeaderAction): void;
    setDefaultView(defaultView: DefaultView): void;
    setCalendarAnimation(calAnimation: IMyCalendarAnimation, isOpen: boolean): void;
    resetDateValue(): void;
    clearDate(): void;
    resetMonthYearSelect(): void;
    onMonthViewBtnClicked(): void;
    monthViewBtnClicked(): void;
    onMonthCellClicked(cell: IMyCalendarMonth): void;
    onMonthCellKeyDown(event: any): void;
    onYearViewBtnClicked(): void;
    yearViewBtnClicked(): void;
    onYearCellClicked(cell: IMyCalendarYear): void;
    onYearCellKeyDown(event: any): void;
    generateMonths(): void;
    generateYears(inputYear: number): void;
    onTodayFooterClicked(): void;
    getYearValueByRowAndCol(row: number, col: number): number;
    setCalendarVisibleMonth(): void;
    onViewActivated(event: any): void;
    onPrevNavigateBtnClicked(): void;
    onNextNavigateBtnClicked(): void;
    setDateViewMonth(isNext: boolean): void;
    onCloseSelector(event: any): void;
    onDayCellClicked(cell: IMyCalendarDay): void;
    onDayCellKeyDown(event: any): void;
    getSourceRowAndColumnFromEvent(event: any): any;
    getTargetFocusRowAndColumn(event: any, row: number, col: number, rowCount: number, colCount: number): any;
    focusCellElement(type: string, row: number, col: number, direction: boolean, colCount: number): void;
    focusToSelector(): void;
    getCalendarElements(): any;
    selectDate(date: IMyDate): void;
    monthStartIdx(y: number, m: number): number;
    isCurrDay(d: number, m: number, y: number, today: IMyDate): boolean;
    getDayNumber(date: IMyDate): number;
    getWeekday(date: IMyDate): string;
    sundayIdx(): number;
    generateCalendar(m: number, y: number, notifyChange: boolean): void;
    setDateViewHeaderBtnDisabledState(m: number, y: number): void;
    setMonthViewHeaderBtnDisabledState(y: number): void;
    setYearViewHeaderBtnDisabledState(yp: number, yn: number): void;
    swapHeaderBtnDisabled(): void;
    onDateResetBtnClicked(): void;
    onTimeChanged($event: any): void;
    catchEvent($event: any): void;
}
